# -*- coding: UTF-8 -*-
from mod.client.ui.screenNode import ScreenNode
import mod.client.extraClientApi as clientApi


class Main(ScreenNode):

    def __init__(self, namespace, name, param):
        ScreenNode.__init__(self, namespace, name, param)
        self.base_screen = "variables_button_mappings_and_controls/safezone_screen_matrix/inner_matrix/safezone_screen_panel/root_screen_panel"
        self.text_path = "/text"
        self.ui_init_finished = False

    def Create(self):
        # 设置滚动弹幕内容
        self.SetText(self.base_screen + self.text_path, '这是一条弹幕公告')
        # 由于PushScreen接口创建的界面不会立即创建，在Update函数内不停更新的text节点需要等到这里执行完毕才能开始工作
        self.ui_init_finished = True

    def Update(self):
        # 当UI完全加载好后
        if self.ui_init_finished:
            # 获得当前的text节点位置
            before_pos = self.GetPosition(self.base_screen + self.text_path)
            # 不停向右增加2像素
            self.SetPosition(self.base_screen + self.text_path, (before_pos[0] + 2, before_pos[1]))
            # 取一个接近让text完全从屏幕上消失的坐标位置，比如当它的X坐标大于100时，此时已经完全消失了，则关闭UI
            if before_pos[0] >= 100.0:
                clientApi.PopScreen()
